var resourceJSON = "";

function getUrl() {
    "use strict";
    // In real bits, urls get returned to our script like this:
    // ms-appx-web://microsoft.microsoftedge/assets/errorpages/dnserror.html#http://www.docUrl.com/bar.htm
    // For testing set docUrl = "ms-appx-web://microsoft.microsoftedge/assets/errorpages/dnserror.html#https://www.microsoft.com/bar.htm"

    var docUrl = document.location.href;

    // Get location of start of url after the #
    var beginIndex = docUrl.indexOf('#') + 1;

    var urlResult;
    // For file:// urls, show the entire url.  Otherwise, restrict to the domain.
    if (docUrl.indexOf("file://", beginIndex) == -1) {
        // Looking for the :// after the protocol but skipping the ms-appx-web://
        var protocolEndIndex = docUrl.indexOf("://", beginIndex);

        // This finds the ending slash for the domain server
        var endIndex = docUrl.indexOf("/", protocolEndIndex + 3);
        urlResult = docUrl.substring(beginIndex, endIndex);
    }
    else {
        urlResult = docUrl.substring(beginIndex);
    }

    return urlResult
}

function isExternalUrlSafeForNavigation(urlStr) {
    "use strict";
    var regEx = new RegExp("^(http(s?)|ftp|file)://", "i");
    return regEx.exec(urlStr);
}

function clickRefresh() {
    "use strict";
    var currentLocation = document.location.href;
    var poundIndex = currentLocation.indexOf('#');

    if (poundIndex != -1 && poundIndex + 1 < currentLocation.length && isExternalUrlSafeForNavigation(currentLocation.substring(poundIndex + 1))) {
        window.location.replace(currentLocation.substring(poundIndex + 1));
    }
}

function clickSearch() {
    "use strict";
    var currentLocation = document.location.href;
    var poundIndex = currentLocation.indexOf('#');

    if (poundIndex != -1 && poundIndex + 1 < currentLocation.length && isExternalUrlSafeForNavigation(currentLocation.substring(poundIndex + 1))) {
        window.open('https://www.bing.com/search?q=' + currentLocation.substring(poundIndex + 1) + '&PC=MENEPB');
    }
}

function getNavigationURL() {
    "use strict";
    var currentLocation = document.location.href;
    var poundIndex = currentLocation.indexOf('#');
    var possibleNavigationURL = currentLocation.substring(poundIndex + 1);

    if (poundIndex != -1 && poundIndex + 1 < currentLocation.length && isExternalUrlSafeForNavigation(possibleNavigationURL)) {
        return possibleNavigationURL;
    } else {
        return '';
    }
}

function isCablefree() {
    "use strict";
    var regExp = new RegExp("[?&;]NoNetworkCables=([^&#;]*)");
    var value = (regExp.exec(document.location.search) || [null, ""])[1];

    return (decodeURIComponent(value) || "0") === "1";
}

function isHostHvsiPolicyEnabled() {
    "use strict";
    var regExp = new RegExp("[?&;]HostHvsiPolicyEnabled=([^&#;]*)");
    var value = (regExp.exec(document.location.search) || [null, ""])[1];

    return (decodeURIComponent(value) || "0") === "1";
}

function isInApplicationGuard() {
    "use strict";
    var regExp = new RegExp("[?&;]InApplicationGuard=([^&#;]*)");
    var value = (regExp.exec(document.location.search) || [null, ""])[1];

    return (decodeURIComponent(value) || "0") === "1";
}

function isNetworkStatusSupported() {
    "use strict";
    var regExp = new RegExp("[?&;]NetworkStatusSupported=([^&#;]*)");
    var value = (regExp.exec(document.location.search) || [null, ""])[1];

    return (decodeURIComponent(value) || "0") === "1";
}

// This function determines the block page URL for pages blocked by parental controls.
function getWpcBlockPageURL() {
    "use strict";

    var params = document.location.search;
    var server = "origin.sdx.microsoft.com";

    var errorParam = "error=100004&"
    var queryIdx = params.indexOf(errorParam);
    if (queryIdx != -1) {
        params = params.substring(queryIdx + errorParam.length);
    }

    var isIntEnv = "env=int&";
    var intIdx = params.indexOf(isIntEnv);
    if (intIdx != -1) {
        server = "sdx.microsoft-int.com";
        params = params.substring(intIdx + isIntEnv.length);
    }
    return 'https://' + server + '/family/restricted-web2?' + params;
}

// This function sets the URL for the "Ask for permission" button for pages blocked by parental controls.
function handleWpcBlockedFrame() {
    "use strict";
    var link = document.getElementById('wpcReqAcc');
    if (link) {
        link.href = getWpcBlockPageURL();
    }
}

function findValue(key) {
    "use strict";
    var value = '';

    var DocQuery = document.location.href;
    var BeginString = DocQuery.indexOf(key);

    if (BeginString > 0) {
        BeginString += key.length;
        var ampLocation = DocQuery.indexOf("&", BeginString);
        var poundLocation = DocQuery.indexOf("#", BeginString);

        var EndString = 0;
        if (ampLocation > 0 && poundLocation > 0) {
            EndString = Math.min(ampLocation, poundLocation);
        }
        else if (ampLocation > 0) {
            EndString = ampLocation;
        }
        else if (poundLocation > 0) {
            EndString = poundLocation;
        }

        if (EndString > 0) {
            value = DocQuery.substring(BeginString, EndString);
        }
        else {
            value = DocQuery.substring(BeginString);
        }
    }

    return value;
}

function getDisplayValue(elem) {
    "use strict";
    var objStyle;
    if (window.getComputedStyle) {
        objStyle = window.getComputedStyle(elem);
    } else {
        objStyle = elem.currentStyle;
    }
    return objStyle.display;
}

function initMoreInfo(infoBlockID, moreInfoText) {
    "use strict";
    document.getElementById("moreInformationDropdownLink").setAttribute("aria-label", moreInfoText);
    document.getElementById("moreInformationDropdownLink").setAttribute("aria-controls", infoBlockID);
    document.getElementById("moreInformationDropdownSpan").innerText = moreInfoText;

    expandCollapseDetails(infoBlockID);
}

function expandCollapseDetails(elem) {
    "use strict";
    if (document.getElementById) {
        var ecBlock = document.getElementById(elem);
        var ecLink = document.getElementById("moreInformationDropdownLink");

        if (ecBlock != null && ecLink != null) {
            var displayValue = getDisplayValue(ecBlock);
            if (displayValue == "none" || displayValue == null || displayValue == "") {
                //shows the info.
                ecBlock.style.display = "block";
                ecLink.setAttribute("aria-expanded", true);
                ecBlock.setAttribute("aria-hidden", false);
            }
            else if (displayValue == "block") {
                //hide info
                ecBlock.style.display = "none";
                ecLink.setAttribute("aria-expanded", false);
                ecBlock.setAttribute("aria-hidden", true);
            }
            else {
                //catch any weird circumstances.
                ecBlock.style.display = "block";
                ecLink.setAttribute("aria-expanded", true);
                ecBlock.setAttribute("aria-hidden", false);
            }
        }
    }
}

function getCertErrorInfo() {
    "use strict";

    var iError = certError();
    var iPolicy = preventIgnoreCertErrors();
    var sRealPageUrl = getNavigationURL();

    // list of certificate errors 

    // SecFlag: DLG_FLAGS_INVALID_CA   0x01000000
    var iCertUnknownCA = 16777216;

    // SecFlag: DLG_FLAGS_SEC_CERT_DATE_INVALID  0x04000000
    var iCertExpired = 67108864;

    // SecFlag: DLG_FLAGS_SEC_CERT_CN_INVALID   0x02000000
    var iCertCNMismatch = 33554432;

    // SecError: ERROR_INTERNET_SEC_CERT_REVOKED 12170
    var iCertRevoked = 12170;

    // SecFlag: DLG_FLAGS_WEAK_SIGNATURE 0x00200000
    var iCertWeakSignature = 2097152;

    var certReasons = [];
    var errorCodes = [];

    // show the cert errors
    if (iError == iCertRevoked) {
        certReasons.push(L_CertRevoked_TEXT);
        errorCodes.push("ERROR_INTERNET_SEC_CERT_REVOKED");
        if (document.getElementById("override")) {
            document.getElementById("override").style.display = "none";
        }
    }
    else {
        if (iError & iCertUnknownCA) {
            certReasons.push(L_CertUnknownCA_TEXT);
            errorCodes.push("DLG_FLAGS_INVALID_CA");
        }

        if (iError & iCertExpired) {
            certReasons.push(L_CertExpired_TEXT);
            errorCodes.push("DLG_FLAGS_SEC_CERT_DATE_INVALID");
        }

        if (iError & iCertCNMismatch) {
            certReasons.push(L_CertCNMismatch_TEXT);
            errorCodes.push("DLG_FLAGS_SEC_CERT_CN_INVALID");
        }

        if (iError == 0) {
            certReasons.push(L_CertSigFailed_TEXT);
            errorCodes.push("0");
        }

        if (iError & iCertWeakSignature) {
            certReasons.push(L_CertWeakSignature_TEXT);
            errorCodes.push("DLG_FLAGS_WEAK_SIGNATURE");
        }

        if (document.getElementById("override")) {
            if (iPolicy == 1 || iError == 0) {
                document.getElementById("override").style.display = "none";
            }
            else {
                document.getElementById("overridelink").href = sRealPageUrl;
            }
        }
    }

    if (certReasons.length > 0) {
        document.getElementById("certReason").innerHTML = certReasons.join("<br>");
    }

    if (errorCodes.length > 0) {
        document.getElementById("ErrorCode").innerHTML = L_ERROR_CODE_TEXT + errorCodes.join("<br>");
    }
}

function certError() {
    "use strict";

    var error = '0';

    var DocQuery = document.location.search;
    var BeginError = DocQuery.indexOf("SSLError=");

    if (BeginError > 0) {
        BeginError += 9;
        var EndError = DocQuery.indexOf("&", BeginError);

        if (EndError > 0) {
            error = DocQuery.substring(BeginError, EndError);
        }
        else {
            error = DocQuery.substring(BeginError);
        }
    }

    return error;
}

function preventIgnoreCertErrors() {
    "use strict";

    var Policy = '0';

    var DocQuery = document.location.search;
    var BeginPolicy = DocQuery.indexOf("PreventIgnoreCertErrors=") + 24;
    if (BeginPolicy > 0) {
        var EndPolicy = DocQuery.indexOf("&", BeginPolicy);
        if (EndPolicy > 0) {
            Policy = DocQuery.substring(BeginPolicy, EndPolicy);
        }
        else {
            Policy = DocQuery.substring(BeginPolicy);
        }
    }

    return Policy;
}

function setGoHomeTarget() {
    "use strict";
    var link = document.getElementById("gohome");
    if (link) {
        var ntpUrl = findValue("NTPUrl=");
        if (ntpUrl) {
            link.href = ntpUrl;
        }
    }
}
